local StopHealingMobs = LibStub("AceAddon-3.0"):NewAddon("StopHealingMobs", "AceEvent-3.0", "LibSink-2.0")
local L = LibStub:GetLibrary("AceLocale-3.0"):GetLocale("StopHealingMobs")
local addon = StopHealingMobs
local counter = 0
local victims = {}
local pairs = _G.pairs
local fmt = _G.string.format
local sub = _G.string.sub
local tonumber = _G.tonumber
local UnitGUID = _G.UnitGUID
local UnitExists = _G.UnitExists
local vezax = 33271
local db

local defaults = {
	profile = {
		sinkOptions = {
			sink20OutputSink = "ChatFrame",
		},
	},
}

local options = {
	type = 'group',
	args = {
		output = addon:GetSinkAce3OptionsDataTable(),
	},
}

local function getID(guid)
	return tonumber(sub(guid,-12,-7),16)
end

function addon:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("StopHealingMobsDB", defaults, "Default")
	db = self.db.profile
	LibStub("AceConfigRegistry-3.0"):RegisterOptionsTable("StopHealingMobs", options)
	self:SetSinkStorage(self.db.profile.sinkOptions)

	local optFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("StopHealingMobs", "StopHealingMobs")
end

function addon:OnEnable()
	self:RegisterEvent("PLAYER_TARGET_CHANGED")
	self:RegisterEvent("UPDATE_MOUSEOVER_UNIT")
end

function addon:CheckEnable(unit)
	if UnitExists(unit) and getID(UnitGUID(unit)) == vezax then
		self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	end
end

function addon:PLAYER_TARGET_CHANGED()
	self:CheckEnable("target")
end

function addon:UPDATE_MOUSEOVER_UNIT()
	self:CheckEnable("mouseover")
end

function addon:COMBAT_LOG_EVENT_UNFILTERED(event, timestamp, eventType, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, spellID, spellName, spellFlags, amount, ...)
	if eventType == "SPELL_HEAL" and spellID == 63278 then 
		counter = counter + amount	
	elseif eventType == "SPELL_DAMAGE" and spellID == 63278 then
		victims[dstName] = victims[dstName] or 0
		victims[dstName] = victims[dstName] + amount
	elseif eventType == "SPELL_AURA_REMOVED" and spellID == 63276 then
		local details
		for k,v in pairs(victims) do
			details = fmt("%s%s%s: %s", details or "", (details and "," or ""), k, v)
		end
		self:Pour(fmt(L["output"], spellName, dstName, srcName, counter, details or L["No Victims"]))
		counter = 0	
		victims = {}
	elseif eventType == "UNIT_DIED" then
		if getID(dstGUID) == vezax then
			self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")	
			self:UnregisterEvent("PLAYER_TARGET_CHANGED")	
			self:UnregisterEvent("UPDATE_MOUSEOVER_UNIT")	
		end
	end
end
